var FWEditor = (function() {
	var version = "0.5";
	var lastupdate = "2017/09/22";
	var idcount = 0;
	var Sqsize = 16;
	var Maxwidth = 100;
	var Maxheight = 100;
	var Defaultwidth = 20;
	var Defaultheight = 20;

	var Toolpx = 20;
	var Toolpy = 20;

	var Tool_terrain_space = 30;
	var Tool_terrain_xnum = 7;
	var Tool_building_margin = 20;
	var Tool_extra_margin = 20;

	var Toolwidth = Toolpx * 2 + Tool_terrain_space * (Tool_terrain_xnum - 1) + Sqsize;
	var Toolheight = 0;//Toolpy * 2 + Tool_terrain_space + Tool_building_margin + Tool_terrain_space * 6 + Sqsize;

	var Tool_select_rectsize = Sqsize + 8;
	var Tool_select_rectcolor = "gray";
	var Tool_select = 0;

	var tx, ty;

	var mx, my;
	var dragx = 0;
	var dragy = 0;

	function getmyid() {
		idcount++;
		return idcount;
	}

	function Rect(x, y, w, h) {
		this.x = +x || 0;
		this.y = +y || 0;
		this.w = +w || 10;
		this.h = +h || 10;
	}
	Rect.prototype.isinside = function(x, y) {
		x = +x || 0;
		y = +y || 0;
		if (this.x <= x && x < this.x + this.w && this.y <= y && y < this.y + this.h) {
			return true;
		}
		else {
			return false;
		}
	}

	var Terrain = [
		{	fname:	"plain", def: 1, land: true, receiveshadow: true },
		{	fname:	"plain_pd", def: 1, land: true },
		{	fname:	"wood", def: 2, land: true, shadow: true },
		{	fname:	"mountain", def: 3, land: true, shadow: true },
		{	fname:	"road", def: 0, land: true, connect: true, receiveshadow: true },
		{	fname:	"bridge", def: 0, connect: true },
		{	fname:	"missle", def: 0, land: true, shadow: true },
		{	fname:	"sea", def: 0, sea: true, connect: true },
		{	fname:	"reef", def: 1, sea: true },
		{	fname:	"shoal", def: 0, sea: true, connect: true },
		{	fname:	"river", def: 0, land: true, connect: true },
		{	fname:	"pipe", def: 0, land: true, pipe: true, connect: true },
		{	fname:	"pipe_c", def: 0, land: true, pipe: true, connect: true, candestroy: true, hp: 99 },
		{	fname:	"misslenone", def: 0, land: true, shadow: true },
	];

	var Building = [
		{	fname:	"hq", def: 4, land: true, building: true, income: true, hq: true, shadow: true },
		{	fname:	"city", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"base", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"airport", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"seaport", def: 3, land: true, building: true, income: true, shadow: true },
		{	fname:	"comtower", def: 3, land: true, building: true, shadow: true },
		{	fname:	"rlab", def: 4, land: true, building: true, income: true, hq: true, shadow: true },
	]

	var Extra = [
		{	fname:	"mcannon_l", land: true, candestroy: true, hp: 99, shadow: true },
		{	fname:	"mcannon_u", land: true, candestroy: true, hp: 99, shadow: true },
		{	fname:	"mcannon_r", land: true, candestroy: true, hp: 99, shadow: true },
		{	fname:	"mcannon_d", land: true, candestroy: true, hp: 99, shadow: true },
		{	fname:	"mcannon_all", land: true, candestroy: true, hp: 99, shadow: true },
		{	fname:	"bstone", land: true, candestroy: true, hp: 99, shadow: true },
		{	fname:	"pipe_ch", land: true, pipe: true, candestroy: true, hp: 99 },
		{	fname:	"pipe10", land: true, pipe: true },
		{	fname:	"pipe5", land: true, pipe: true },
		{	fname:	"pipe9", land: true, pipe: true },
		{	fname:	"pipe3", land: true, pipe: true },
		{	fname:	"pipe6", land: true, pipe: true },
		{	fname:	"pipe12", land: true, pipe: true },
		{	fname:	"pipe_cv", land: true, pipe: true, candestroy: true, hp: 99 },
		{	fname:	"bcannon_u", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"bcannon_d", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"bcannon2", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"bcrystal", land: true, large: true, size: 3, destroyx: 1, destroyy: 2 },
		{	fname:	"volcano", land: true, large: true, size: 4 },
		{	fname:	"blackarc", land: true, large: true, size: 4 },
		{	fname:	"blackarc2", sea: true, large: true, size: 4 },
		{	fname:	"largebuilding", land: true, large: true, size: 4 },
		{	fname:	"misslelauncher", land: true, large: true, size: 4 },
	]

	var Country = [ 
		{ fname: "rs" },
		{ fname: "bm" },
		{ fname: "ge" },
		{ fname: "yc" },
		{ fname: "bh" },
		{ fname: "no" },
	];

	var Terrain_pipeindex;
	var Terrain_seaindex;
	var Terrain_plainindex;
	var Maptype = [
		{ fname: "normal" },
	];

	var shadowplainimg = [];
	var shadowroadimg = [];
	for (var k = 0 ; k < Maptype.length ; k++) {
		shadowplainimg[k] = new Image();
  	shadowplainimg[k].src = "image/terrain/" + Maptype[k].fname + "/shadowplain.png";
		shadowroadimg[k] = new Image();
  	shadowroadimg[k].src = "image/terrain/" + Maptype[k].fname + "/shadowroad.png";
	}

	for (var i = 0 ; i < Terrain.length ; i++) {
		var t = Terrain[i];
		if (t.fname == "pipe") {
			Terrain_pipeindex = i;
		}
		if (t.fname == "sea") {
			Terrain_seaindex = i;
		}
		if (t.fname == "plain") {
			Terrain_plainindex = i;
		}
		t.image = [];
		t.cimage = [];
		t.toolrect = new Rect(Toolpx + (i % Tool_terrain_xnum) * Tool_terrain_space, Toolpy + Math.floor(i / Tool_terrain_xnum) * Tool_terrain_space, Tool_terrain_space, Tool_terrain_space);
		for (var j = 0 ; j < Maptype.length ; j++) {
			t.image[j] = new Image();
		  t.image[j].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + ".png";
			if (t.connect) {
				t.cimage[j] = [];
				for (var k = 0 ; k < 16 + ((t.fname == "sea") ? 8 : 0) + ((t.fname == "shoal") ? 24 : 0) ; k++) {
					t.cimage[j][k] = new Image();
				  t.cimage[j][k].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + k + ".png";
				}
			}
			if (t.fname == "pipe_c" || t.fname == "bridge") {
				t.cimage[j] = [];
				t.cimage[j][0] = new Image();
			  t.cimage[j][0].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + "h.png";
				t.cimage[j][1] = new Image();
			  t.cimage[j][1].src = "image/terrain/" + Maptype[j].fname + "/" + t.fname + "v.png";
			}
		}
	}
	Toolheight += Toolpy + 2 * Tool_terrain_space + Tool_building_margin;
	for (var j = 0 ; j < Country.length ; j++) {
		for (var i = 0 ; i < Building.length ; i++) {
			var b = Building[i];
			if (b.hq == true && Country[j].fname == "no") {
				continue;
			}
			var t = Terrain[Terrain.length] = {};
			t.image = [];
			var bkeys = Object.keys(b);
			for (var key in bkeys) {
				t[bkeys[key]] = b[bkeys[key]];
			}
			t.country = Country[j].fname;
			t.countryid = j;
			t.toolrect = new Rect( Toolpx + i * Tool_terrain_space, Toolheight + j * Tool_terrain_space, Tool_terrain_space, Tool_terrain_space);
			for (var k = 0 ; k < Maptype.length ; k++) {
				t.image[k] = new Image();
		  	t.image[k].src = "image/terrain/" + Maptype[k].fname + "/" + t.fname + "_" + Country[j].fname + ".png";
			}
		}
	}
	Toolheight += 6 * Tool_terrain_space + Tool_extra_margin;
	for (var i = 0 ; i < Extra.length ; i++) {
		var e = Extra[i];
		var t = Terrain[Terrain.length] = {};
		t.image = [];
		var ekeys = Object.keys(e);
		for (var key in ekeys) {
			t[ekeys[key]] = e[ekeys[key]];
		}
		t.toolrect = new Rect(Toolpx + (i % Tool_terrain_xnum) * Tool_terrain_space, Toolheight + Math.floor(i / Tool_terrain_xnum) * Tool_terrain_space, Tool_terrain_space, Tool_terrain_space);
		for (var k = 0 ; k < Maptype.length ; k++) {
			t.image[k] = new Image();
	  	t.image[k].src = "image/terrain/" + Maptype[k].fname + "/" + t.fname + ".png";
		}
		if (t.large == true) {
			for (var y = 0 ; y < t.size ; y++) {
				for (var x = 0 ; x < t.size ; x++) {
					var t2 = Terrain[Terrain.length] = {};
					t2.image = [];
					for (var key in ekeys) {
						t2[ekeys[key]] = e[ekeys[key]];
					}
					t2.x = x;
					t2.y = y;
					t2.donotdrawtool = true;
					if (x === t2.destroyx && y === t2.destroyy) {
						t2.candestroy = true;
						t2.hp = 99;
					}
					for (var k = 0 ; k < Maptype.length ; k++) {
						t2.image[k] = t.image[k];
					}
				}
			}
		}
	}
	Toolheight += 4 * Tool_terrain_space + Toolpy;

	function FWEditor(canvasid) {
		var id = getmyid();

		var canvas;
		var ctx;
		var canuse;
		var map, mapbeforedrag;

		var width;
		var height;
		var maptype = 0;

		var usetool = true;

		var me = this;
		
		this.getversion = function() {
			return version;
		}
		this.getlastupdate = function() {
			return lastupdate;
		}
		this.getsize = function() {
			return { width: width, height: height }
		};
		this.setsize = function(w, h) {
			if (w <= 0 || w > Maxwidth) {
				w = Defaultwidth;
			}
			if (h <= 0 || h > Maxheight) {
				h = Defaultheight;
			}
			width = w;
			height = h;
			map = [];
			mapbeforedrag = [];
			for (var x = 0 ; x < width ; x++) {
				map[x] = [];
				for (var y = 0 ; y < height ; y++) {
					map[x][y] = 0; //(x + y * width) % 12;
				}
			}
		}

		this.canuse = function() {
			return canuse;
		}

		this.drawmap = function() {
			for (var y = 0 ; y < height ; y++) {
				for (var x = 0 ; x < width ; x++) {
					var t = Terrain[map[x][y]];
					var img;
					if (t.connect) {
						var c = 0;
						var count = 0;
						var dx = [ 0, 1, 0, -1];
						var dy = [ -1, 0, 1, 0 ];
						var di = [ 1, 3, 0, 2 ];
						var isshoal = [];
						for (var i = 0 ; i < 4 ; i++) {
							var x2 = x + dx[di[i]];
							var y2 = y + dy[di[i]];
							if (this.isinside(x2, y2)) {
								var t2 = Terrain[map[x2][y2]];
								if (t2.fname == "shoal") {
									isshoal[di[i]] = true;
								}
								if ((t.fname == "road" && t2.fname == "road") || 
										(t.fname == "bridge" && (t2.fname == "bridge" || t2.land == true)) ||
										(t.fname == "river" && t2.fname == "river") ||
										(t.fname == "sea" && t2.land == true) ||
										(t.fname == "shoal" && t2.land == true) ||
										(t.pipe == true && t2.pipe == true)) {
									c += Math.pow(2, di[i]);
									count++;
								}
							}
							if (count == 2) {
								if (t.pipe == true) {
									if (t.fname == "pipe") {
										break;
									}
									else if (c == 10) {
										c = 0;
									}
									else if (c == 5) {
										c = 1;
									}
									else {
										map[x][y] = Terrain_pipeindex;
										t = Terrain[Terrain_pipeindex];
									}
									break;
								}
							}
						}
						if (count < 2 && t.fname == "pipe_c") {
								map[x][y] = Terrain_pipeindex;
								t = Terrain[Terrain_pipeindex];
						}
						if (t.fname == "bridge") {
							if (c == 1 || c == 4 || c == 5) {
								c = 1;
							}
							else {
								c = 0;
							}
						}
						if (t.fname == "shoal") {
							var dx = [ 1, 1, -1, -1 ];
							var dy = [ -1, 1, 1, -1 ];
							var island = [];
							for (var i = 0 ; i < 4 ; i++) {
								var x2 = x + dx[i];
								var y2 = y + dy[i];
								if (this.isinside(x2, y2) && Terrain[map[x2][y2]].land == true) {
									island[i] = true;
								}
								else {
									island[i] = false;
								}
							}
							var seaflag = false;
							if (c == 0 || c == 5 || c == 10 || c == 15) {
								seaflag = true;
							}
							for (var i = 0 ; i < 4 ; i++) {
								if (c == Math.pow(2, i) && (island[(i + 1) % 4] == true || island[(i + 2) % 4] == true)) {
									seaflag = true;
									break;
								}
							}
							if (seaflag == true) {
								map[x][y] = Terrain_seaindex;
								t = Terrain[Terrain_seaindex];
							}
							else {
								for (var i = 0 ; i < 4 ; i++) {
									if (c == Math.pow(2, i)) {
										if (isshoal[(i + 3) % 4] == true && isshoal[(i + 1) % 4] == true) {
											c = 16 + i * 3;
										}
										else if (isshoal[(i + 3) % 4] == true) {
											c = 17 + i * 3;
										}
										else if (isshoal[(i + 1) % 4] == true) {
											c = 18 + i * 3;
										}
										break;
									}
									if (c == Math.pow(2, i) + Math.pow(2, (i + 1) % 4)) {
										if (isshoal[(i + 3) % 4] == true && isshoal[(i + 2) % 4] == true) {
											c = 28 + i * 3;
										}
										else if (isshoal[(i + 3) % 4] == true) {
											c = 29 + i * 3;
										}
										else if (isshoal[(i + 2) % 4] == true) {
											c = 30 + i * 3;
										}
										break;
									}
								}		
							}
						}
						if (t.fname == "sea") {
							var dx = [ 0, 1, 1, 1, 0, -1, -1, -1 ];
							var dy = [ -1, -1, 0, 1, 1, 1, 0, -1 ];
							var island = [];
							var isriver = [];
							for (var i = 0 ; i < 8 ; i++) {
								var x2 = x + dx[i];
								var y2 = y + dy[i];
								island[i] = isriver[i] = false;
								if (this.isinside(x2, y2)) {
									var t2 = Terrain[map[x2][y2]];
									if (t2.land == true) {
										island[i] = true;
									}
									if (t2.fname == "river") {
										if (i == 0 || i == 4) {
											y2 += dy[i];
											if (this.isinside(x2, y2) && Terrain[map[x2][y2]].fname == "river") {
												isriver[i] = true;
											}
										}
										else {
											isriver[i] = true;
										}
									}
								}
							}
							for (var i = 0 ; i < 8 ; i += 2) {
								if (isriver[i] && !isriver[(i + 7) % 8] && !isriver[(i + 1) % 8] && !island[(i + 2) % 8] && !island[(i + 3) % 8] && !island[(i + 4) % 8] && !island[(i + 5) % 8] && !island[(i + 6) % 8]) {
									c = 20 + i / 2;
									break;
								}
							}
						}
						img = t.cimage[maptype][c];
					}
					else {
						img = t.image[maptype];
					}
					if (t.land) {
						ctx.drawImage(Terrain[Terrain_plainindex].image[maptype], x * Sqsize, y * Sqsize);
					}
					if (t.large) {
						ctx.drawImage(img, t.x * Sqsize, t.y * Sqsize, Sqsize, Sqsize, x * Sqsize, y * Sqsize, Sqsize, Sqsize);
					}
					else {
						ctx.drawImage(img, x * Sqsize, (y + 1) * Sqsize - img.height);
					}
					if (x > 0 && t.receiveshadow && Terrain[map[x - 1][y]].shadow) {
						if (t.fname == "plain") {
							ctx.drawImage(shadowplainimg[maptype], x * Sqsize, y * Sqsize);
						}
						else {
							ctx.drawImage(shadowroadimg[maptype], x * Sqsize, y * Sqsize);
						}
					}
					if (t.fname == "sea") {
						var dx = [ [ 1, 1, -1, -1], [ 0, 1, 0, -1], [ 1, 0, -1, 0] ];
						var dy = [ [ -1, 1, 1, -1 ], [ -1, 0, 1, 0 ], [ 0, 1, 0, -1 ] ];
						var island = [];
						for (var i = 0 ; i < 4 ; i++) {
							for (var j = 0 ; j < 3 ; j++) {				
								var x2 = x + dx[j][i];
								var y2 = y + dy[j][i];
								if (this.isinside(x2, y2) && Terrain[map[x2][y2]].land == true) {
									island[j] = true;
								}
								else {
									island[j] = false;
								}
							}
							if (island[0] == true && island[1] == false && island[2] == false) {
								ctx.drawImage(t.cimage[maptype][16 + i], x * Sqsize, (y + 1) * Sqsize - img.height);
							}
						}
					}
				}
			}
		}

		this.copymap = function(from, to) {
			for (var x = 0 ; x < width ; x++) {
				to[x] = [];
				for (var y = 0 ; y < height ; y++) {
					to[x][y] = from[x][y];
				}
			}
		}
		this.restoremap = function() {
			this.copymap(mapbeforedrag, map);
		}
		this.backupmap = function() {
			this.copymap(map, mapbeforedrag);
		}

		this.drawtool = function() {
			ctx.beginPath();
			ctx.fillStyle = Tool_select_rectcolor;
			ctx.rect(tx + Terrain[Tool_select].toolrect.x - (Tool_select_rectsize - Sqsize) / 2, Terrain[Tool_select].toolrect.y - (Tool_select_rectsize - Sqsize) / 2, ty + Tool_select_rectsize, Tool_select_rectsize);
			ctx.fill();

			for (var i = 0 ; i < Terrain.length ; i++) {
				var t = Terrain[i];
				if (t.donotdrawtool) {
					continue;
				}
				if (t.land) {
					ctx.drawImage(Terrain[Terrain_plainindex].image[maptype], tx + t.toolrect.x, ty + t.toolrect.y,);
				}
				if (t.large) {
					ctx.drawImage(t.image[0], tx + t.toolrect.x, ty + t.toolrect.y, Sqsize, Sqsize);
				}
				else {
					ctx.drawImage(t.image[0], tx + t.toolrect.x, ty + t.toolrect.y + Sqsize - t.image[0].height, Sqsize, t.image[0].height);
				}
			}
		}

		this.draw = function() {
			ctx.fillStyle = "rgb(240, 240, 240)";
			ctx.beginPath();
			ctx.rect(0, 0, canvas.width, canvas.height);
			ctx.fill();
			this.drawmap();
			if (usetool) {
				this.drawtool();
			}
		}

		this.isinside = function(x, y) {
			if (0 <= x && x < width && 0 <= y && y < height) {
				return true;
			}
			else {
				return false;
			}	
		}

		this.cansetreef = function(x, y) {
			for (var dx = -1 ; dx <= 1 ; dx++) {
				for (var dy = -1 ; dy <= 1 ; dy++) {
					if (dx == 0 && dy == 0) {
						continue;
					}
					var x2 = x + dx;
					var y2 = y + dy;
					if (this.isinside(x2, y2) && Terrain[map[x2][y2]].land == true) {
						return false;
					}
				}
			}
			return true;
		}

		this.cansetriver = function(x, y) {
			var dx = [ 0, 0, -1, -1 ];
			var dy = [-1, 0, -1, 0 ];
			for (var i = 0 ; i < 4 ; i++) {
				var x2 = x + dx[i];
				var y2 = y + dy[i];
				var allriver = true;
				for (var dx2 = 0 ; dx2 <= 1 ; dx2++) {
					for (var dy2 = 0 ; dy2 <= 1 ; dy2++) {
						if (dx[i] + dx2 == 0 && dy[i] + dy2 == 0) {
							continue;
						}
						var x3 = x2 + dx2;
						var y3 = y2 + dy2;
						if (!this.isinside(x3, y3) || Terrain[map[x3][y3]].fname != "river") {
							allriver = false;
						}
					}
				}
				if (allriver == true) {
					return false;
				}
			}
			return true;
		}

		this.deletenearreef = function(x, y) {
			if (this.isinside(x, y)) {
				for (var dx = -1 ; dx <= 1 ; dx++) {
					for (var dy = -1 ; dy <= 1 ; dy++) {
						if (dx == 0 && dy == 0) {
							continue;
						}
						var x2 = x + dx;
						var y2 = y + dy;
						if (this.isinside(x2, y2) && Terrain[map[x2][y2]].fname == "reef") {
							map[x2][y2] = Terrain_seaindex;
						}
					}
				}
			}
		}

		this.changemap = function(x, y, tid) {
			var t = Terrain[tid];
			if (this.isinside(x, y)) {
				var t2 = Terrain[map[x][y]];
				if (t2.large == true) {
					for (var dx = 0 ; dx < t2.size ; dx++) {
						for (var dy = 0 ; dy < t2.size ; dy++) {
							var x2 = x - t2.x + dx;
							var y2 = y - t2.y + dy;
							map[x2][y2] = Terrain_plainindex;
							this.deletenearreef(x2, y2);
						}
					}
				}
				map[x][y] = tid;
				if (t.land == true) {
					this.deletenearreef(x, y);
				}
			}
		}

		this.setmap = function(x, y, tid, check) {
			check = check || false;
			retval = false;
			var t = Terrain[tid];
			if (this.isinside(x, y)) {
				if (t.fname == "pipe_c") {
					if (map[x][y] == Terrain_pipeindex && 
						((this.isinside(x - 1, y) && Terrain[map[x - 1][y]].fname == "pipe" && this.isinside(x + 1, y) && Terrain[map[x + 1][y]].fname == "pipe") ||
						 (this.isinside(x, y - 1) && Terrain[map[x][y - 1]].fname == "pipe" && this.isinside(x, y + 1) && Terrain[map[x][y + 1]].fname == "pipe"))) {
							retval = true;
							if (!check) {
								this.changemap(x, y, tid);
							}
					}
				}
				else if (t.fname == "reef") {
					if (Terrain[map[x][y]].fname == "sea") {
						retval = true;
						if (!check) {
							this.changemap(x, y, tid);
							for (var dx = -1 ; dx <= 1 ; dx++) {
								for (var dy = -1 ; dy <= 1 ; dy++) {
									if (dx == 0 && dy == 0) {
										continue;
									}
									var x2 = x + dx;
									var y2 = y + dy;
									if (this.isinside(x2, y2) && Terrain[map[x2][y2]].sea != true) {
										this.changemap(x2, y2, Terrain_seaindex);
									}
								}
							}
						}
					}
				}
				else if (t.fname == "shoal") {
					if (Terrain[map[x][y]].fname == "sea") {
						retval = true;
						if (!check) {
							this.changemap(x, y, tid);
						}
					}
				}
				else if (t.fname == "river") {
					if (Terrain[map[x][y]].land == true || Terrain[map[x][y]].pipe == true) {
						if (this.cansetriver(x, y)) {
							retval = true;
							if (!check) {
								this.changemap(x, y, tid);
							}
						}
					}
				}
				else if (t.hq == true && t.country != "no") {
					retval = true;
					if (!check) {
						for (var x2 = 0; x2 < width ; x2++) {
							for (var y2 = 0 ; y2 < height ; y2++) {
								var t2 = Terrain[map[x2][y2]];
								if (t2.hq == true && t.country == t2.country) {
									this.changemap(x2, y2, Terrain_plainindex);
								}
							}
						}
						this.changemap(x, y, tid);
					}
				}
				else if (t.large) {
					if (x + t.size - 1 < width && y + t.size - 1 < height) {
						retval = true;
						if (!check) {
							for (var dy = 0 ; dy < t.size ; dy++) {
								for (var dx = 0 ; dx < t.size ; dx++) {
									this.changemap(x + dx, y + dy, tid + dy * t.size + dx + 1);
								}
							}
						}
					}
				}
				else {
					retval = true;
					if (!check) {
						this.changemap(x, y, tid);
					}
				}
			}
			return retval;
		}

		this.init = function(canvasid) {
			canvas = document.getElementById(canvasid);
		  if (!canvas || !canvas.getContext) {
    		return false;
  		}
			canvas.width = Sqsize * width;
			canvas.height = Sqsize * height;
			if (usetool) {
				canvas.width += Toolwidth;
				if (canvas.height < Toolheight) {
					canvas.height = Toolheight;
				}
			}
			ctx = canvas.getContext('2d');

			tx = Sqsize * width;
			ty = 0;

			canvas.onmousemove = function(evt) {
				var rect = canvas.getBoundingClientRect();
				mx = Math.floor(evt.clientX - rect.left);
				my = Math.floor(evt.clientY - rect.top);
				if (usetool) {
					var cx = Math.floor(mx / Sqsize);
					var cy = Math.floor(my / Sqsize);
					if (evt.buttons & 1) {
						me.setmap(cx, cy, Tool_select);
					}
					else if (evt.buttons & 2) {
						var fromx = (cx < dragx) ? cx : dragx;
						var fromy = (cy < dragy) ? cy : dragy;
						var tox = (cx > dragx) ? cx : dragx;
						var toy = (cy > dragy) ? cy : dragy;
						var plus = (Terrain[Tool_select].large) ? Terrain[Tool_select].size : 1;
						me.restoremap();
						for (var x = dragx ; (dragx < cx) ? x <= cx : x >= cx ; x += plus * ((dragx < cx) ? 1 : -1)) {
							for (var y = dragy ; (dragy < cy) ? y <= cy : y >= cy ; y += plus * ((dragy < cy) ? 1 : -1)) {
								me.setmap(x, y, Tool_select);
							}
						}
					}
				}
				me.draw();
			}
			canvas.onmousedown = function(evt) {
				var rect = canvas.getBoundingClientRect();
				mx = Math.floor(evt.clientX - rect.left);
				my = Math.floor(evt.clientY - rect.top);
				if (evt.buttons & 2) {
					me.backupmap();
					dragx = Math.floor(mx / Sqsize);;
					dragy = Math.floor(my / Sqsize);;
				}

				if (usetool) {
					this.onmousemove(evt);

					for (var i = 0 ; i < Terrain.length ; i++) {
						var t = Terrain[i];
						if (t.donotdrawtool != true && t.toolrect.isinside(mx - tx, my - ty)) {
							Tool_select = i;
							break;
						}
					}
				}
				me.draw();
			}
			canvas.onmouseup = function(evt) {
				var rect = canvas.getBoundingClientRect();
				mx = Math.floor(evt.clientX - rect.left);
				my = Math.floor(evt.clientY - rect.top);
				me.draw();
			}
			canvas.addEventListener('DOMMouseScroll', mouseWheelEvent);
			canvas.onmousewheel = function(evt) {
				mouseWheelEvent(evt);
			}
			function mouseWheelEvent(evt) {
				var delta = evt.wheelDelta ? evt.wheelDelta : evt.detail;
				if (delta > 0) {
					while (1) {
						Tool_select++;
						if (Terrain.length <= Tool_select) {
							Tool_select = 0;
							break;
						}
						if (Terrain[Tool_select].x !== undefined) {
							continue;
						}
						break;
					}
				}
				else {
					while (1) {
						Tool_select--;
						if (Tool_select < 0) {
							Tool_select = Terrain.length - 1;
						}
						if (Terrain[Tool_select].x !== undefined) {
							continue;
						}
						break;
					}
				}
				me.draw();
			}
			canvas.onmouseout = function(evt) {
				dragflag = false;
			}
			canvas.oncontextmenu = function(evt) {
				return false;
			}
			return true;
		}

		this.setsize(Defaultwidth, Defaultheight);
		canuse = this.init(canvasid);
		this.draw();

	}
	return FWEditor;
}());
